



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>在django中使用Redis存取session</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">在django中使用Redis存取session</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 06:41:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一.Redis的配置</h2>
<p>1.django的缓存配置</p>
<div>
<pre class="prettyprint linenums"># redis在django中的配置<br />
CACHES = {<br />
    "default": {<br />
        "BACKEND": "django_redis.cache.RedisCache",<br />
        "LOCATION": "redis://127.0.0.1:6379",<br />
        "OPTIONS": {<br />
            "CLIENT_CLASS": "django_redis.client.DefaultClient",<br />
            "CONNECTION_POOL_KWARGS": {"max_connections": 100}<br />
            # "PASSWORD": "123",<br />
        }<br />
    }<br />
}</pre>
</div>
<p>2.django中session的配置</p>
<div>
<pre class="prettyprint linenums"># session的存储配置<br />
SESSION_ENGINE = 'django.contrib.sessions.backends.cache'<br />
SESSION_CACHE_ALIAS = 'default'

# 设置session失效时间,单位为秒<br />
SESSION_COOKIE_AGE = 60*5</pre>
</div>
<p>配置完这个2个后,在视图中再设置session,就会自动将session保存在Redis中</p>
<h2>二.路由</h2>
<div>
<pre class="prettyprint linenums">from django.conf.urls import url<br />
from django.contrib import admin<br />
from api import views<br />
urlpatterns = [<br />
    url(r'^admin/', admin.site.urls),<br />
    url(r'^session/$',views.SetSession.as_view() ),<br />
]</pre>
</div>
<h2>三.视图</h2>
<p>这里视图使用的是MBV,还用了restframework</p>
<div>
<pre class="prettyprint linenums">from rest_framework.views import APIView<br />
# Create your views here.<br />
from rest_framework.response import Response<br />
from api import models

class MyResponse():<br />
    def __init__(self):<br />
        self.status=100<br />
        self.msg=None

    @property<br />
    def get_dic(self):<br />
        return self.__dict__

class SetSession(APIView):<br />
    # 设置session,直接request.session就自动把session值保存到Redis中了<br />
    def post(self,request):<br />
        response = MyResponse()<br />
        request.session["username"]="django"<br />
        request.session["verify_code"]=""<br />
        response.msg="保存session成功"<br />
        return Response(response.get_dic)

    # 获取session,直接从request.session中取session的值<br />
    def get(self,request):<br />
        response = MyResponse()<br />
        username_redis=request.session.get("username")<br />
        verify_code_redis=request.session.get("verify_code")<br />
        print(username_redis,verify_code_redis)<br />
        if username_redis=="django" and verify_code_redis=="":<br />
            response.msg="验证成功"<br />
            return Response(response.get_dic)<br />
        response.msg="验证失败"<br />
        response.status=101<br />
        return Response(response.get_dic)</pre>
</div>
<h2>四.浏览器发送请求</h2>
<p>这里使用了postman</p>
<p>设置session用了post请求</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1449147/201902/1449147-20190228170943585-721919561.png" /></p>
<p>获取session用了get请求</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1449147/201902/1449147-20190228171029714-1464945312.png" /></p>
<h2>五.cache组件存取token</h2>
<p>需要联合restframework认证组件一起使用</p>
<p>1.先创建一个认证类</p>
<div>
<pre class="prettyprint linenums">from rest_framework.authentication import BaseAuthentication<br />
from django.core.cache import cache<br />
from api import models<br />
from rest_framework.exceptions import AuthenticationFailed

class LoginAuth(BaseAuthentication):<br />
    def authenticate(self, request):<br />
        token=request.GEt.get("token")<br />
        # 从Redis中取出token,前提是已经在settings中配置Redis<br />
        user=cache.get(token)<br />
        if user:<br />
            return user,token<br />
        token = models.Token.objects.filter(key=token).first()<br />
        if token:<br />
            return token.user,token<br />
        else:<br />
            raise AuthenticationFailed("你没有登入")</pre>
</div>
<p>2.使用APIView写登入接口</p>
<div>
<pre class="prettyprint linenums">from rest_framework.views import APIView<br />
from rest_framework.response import Response<br />
from api import models<br />
from django.core.exceptions import ObjectDoesNotExist<br />
from uuid import uuid4<br />
from django.core.cache import cache

class MyResponse():<br />
    def __init__(self):<br />
        self.status=100<br />
        self.msg=None

    @property<br />
    def get_dic(self):<br />
        return self.__dict__

class Login(APIView):<br />
    def post(self,request):<br />
        response = MyResponse()<br />
        name=request.data.get("name")<br />
        pwd=request.data.get("pwd")<br />
        try:<br />
            user=models.UserInfo.objects.filter(username=name,password=pwd).first()<br />
        except ObjectDoesNotExist as e:<br />
            response.msg = "没有查收到"<br />
            response.status = 101<br />
            return Response(response.get_dic)<br />
        if user:<br />
            token=uuid4()<br />
            try:<br />
                models.Token.objects.update_or_create(user=user,defaults={'key':token})<br />
                # 将token存到Redis中,设置超时时间一天<br />
                cache.set(token, user, 60 * 60 * 24)<br />
                response.msg = '登录成功'<br />
                response.token = token<br />
                response.name = name<br />
            except ObjectDoesNotExist as e:<br />
                response.msg = "没有查收到"<br />
                response.status = 101<br />
                return Response(response.get_dic)<br />
        else:<br />
            response.msg = '用户名或密码错误'<br />
            response.status = 101

        return Response(response.get_dic)</pre>
</div>
<p>3.最后只要配置需要加登入需求的接口</p>
<p>局部配置:放在视图函数中</p>
<p>authentication_classes=[LoginAuth]</p>
<p>全局配置:settings中</p>
<pre class="prettyprint linenums">REST_FRAMEWORK = {</pre>
<pre class="prettyprint linenums">"DEFAULT_AUTHENTICATION_CLASSES":["导入你写的认证类",]</pre>
<pre class="prettyprint linenums">}</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93vw7z8.html">vi学习 常用命令-新建-复制-剪切-粘贴</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93ee5wq.html">Yii查看执行的SQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdzjgm8.html">UE4简单AI</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mn4kjq.html">JS遇到的问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1kwe8.html">Javascript 绝对定位和相对定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x1pj09.html">JS、C&num;编码解码</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ow2dj9.html">&lbrack;转&rsqb; 学习HTML&sol;JavaScript&sol;PHP 三者的关系以及各自的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gee3k08.html">&lbrack;模式识别&rsqb;&period;&lpar;希腊&rpar;西奥多里蒂斯&amp;amp&semi;lt&semi;第四版&amp;amp&semi;gt&semi;笔记8它&lowbar;&lowbar;模板匹配</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5ymo8.html">javascript立即调用的函数表达式N种写法&lpar;第二篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpm5039.html">JAVA序列化与反序列化三种格式存取（默认格式、XML格式、JSON格式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0kd48.html">Jmeter函数引用和函数重定向</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2nw48.html">Docker - 容器互联</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z3ekg9.html">BZOJ1294&colon; &lbrack;SCOI2009&rsqb;围豆豆Bean</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mrgzq.html">深入浅出Cocoa多线程编程之 block 与 dispatch quene</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ownz8.html">pyqt5在textBrowser添加文本并自动滑动到底</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyw3rjq.html">VS2017提醒找不到MSVCR110D&period;dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyj2639.html">python中深拷贝与浅拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ve4g9.html">跟随我在oracle学习php（8）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkox49.html">java  浅谈web系统当中的cookie和session会话机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komkl5q.html">adb 查看内存信息的命令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gpwyeq.html">socket基础编程-1</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2dw72q.html">java学习之&mdash;队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdlyke9.html">Golang的md5 hash计算</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvowmz8.html">ServiceLoader详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy2lx2q.html">js判断一个元素是否在数组中</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvd6vg8.html">linux常用命令（个人总结）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o7vok8.html">linux系统版本大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj36vz9.html">P2141 珠心算测验</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw51y09.html">POJ 2352 树状数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1e4ml9.html">ram自己写？用IP？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
